#include<stdio.h>
#include <time.h>
#include<stdlib.h>

using namespace std;

#define max 1010
#define N 5

double grid[max][max];
double score;
int size_x, size_y, pos_x, pos_y, moves, print, n;
int dx[4] = {-1, 0, 1, 0};
int dy[4] = {0, 1, 0, -1};

void print_fn()
{
	int i, j;
	for(i=0;i<size_x;i++)
	{
		for(j=0;j<size_y;j++)
			if(pos_x==i&&pos_y==j)
				printf("[%.2lf] ", grid[i][j]);
			else
				printf("%.2lf ", grid[i][j]);
		printf("\n");
	}
	printf("\n");
}

void compute()
{
	srand(time(0));
	int change;
	while(moves>0)
	{
		if(grid[pos_x][pos_y]>0)
		{
			score +=grid[pos_x][pos_y];
			printf("S %.2lf\n", score);
			grid[pos_x][pos_y]=0;
			moves--;
			n++;
			if(n%print==0&&n>0)
				print_fn();
			if(moves==0)
				break;
		}
		//change = random(0, 4);
		change = rand()%4;
		pos_x+=dx[change];
		pos_y+=dy[change];
		while(pos_x<0||pos_x>=size_x||pos_y<0||pos_y>=size_y)
		{
			pos_x-=dx[change];
			pos_y-=dy[change];
			//change = random(0, 4);
			change = rand()%4;
			pos_x+=dx[change];
			pos_y+=dy[change];
		}
		if(change==0)
			printf("U %.2lf\n", score);
		else if(change==1)
			printf("R %.2lf\n", score);
		else if(change==2)
			printf("D %.2lf\n", score);
		else if(change==3)
			printf("L %.2lf\n", score);
		moves--;
		n++;
		if(n%print==0&&n>0)
			print_fn();
	}
	return;
}

int main()
{
	int i, j, k, l;
	char buf[100];
	scanf("GRID: %d %d", &size_x, &size_y);
	//printf("%d %d\n", size_x, size_y);
	scanf("%s", &buf);
	//printf("%s\n", buf);
	for(i=0;i<size_x;i++)
		for(j=0;j<size_y;j++)
		{
			scanf("%lf", &grid[i][j]);
			//printf("%lf ", grid[i][j]);
		}
	scanf("%s %d", &buf, &moves);
	//printf("%d\n", moves);
	scanf("%s %d %d", &buf, &pos_x, &pos_y);
	//printf("%d %d\n", pos_x, pos_y);
	print = N;
	pos_x--;
	pos_y--;
	print_fn();
	score=0.0;
	n=0;
	compute();
	printf("Final Score = %lf\n", score);
	return 0;
}
