#include<stdio.h>
#include <time.h>
#include<stdlib.h>

using namespace std;

#define max 1010
#define N 5

double grid[max][max];
double score;
int size_x, size_y, pos_x, pos_y, moves, print, n, x, y;
int dx[4] = {-1, 0, 1, 0};
int dy[4] = {0, 1, 0, -1};
bool select_option[4];

void print_fn()
{
	int i, j;
	for(i=0;i<size_x;i++)
	{
		for(j=0;j<size_y;j++)
			if(pos_x==i&&pos_y==j)
				printf("[%.2lf] ", grid[i][j]);
			else
				printf("%.2lf ", grid[i][j]);
		printf("\n");
	}
	printf("\n");
}

void compute()
{
	srand(time(0));
	int i, greedy_move, options, j;
	bool br;
	double change;
	while(moves>0)
	{
		if(grid[pos_x][pos_y]>0)
		{
			score +=grid[pos_x][pos_y];
			printf("S %.2lf\n", score);
			grid[pos_x][pos_y]=0;
			moves--;
			n++;
			if(n%print==0&&n>0)
				print_fn();
			if(moves==0)
				break;
		}
		//greedy
		change = 0.00;
		for(i=0;i<4;i++)
		{
			x = pos_x+dx[i];
			y = pos_y+dy[i];
			if(x<0||x>=size_x||y<0||y>=size_y)
				continue;
			if(change<grid[x][y])
			{
				change = grid[x][y];
				select_option[0]=select_option[1]=select_option[2]=select_option[3]=false;
				select_option[i] = true;
				options = 1;
			}
			else if(change==grid[x][y])
			{
				select_option[i] = true;
				options++;
			}
		}
		if(options==1)
		{
			for(j=0;j<4;j++)
				if(select_option[j])
					greedy_move = j;
			pos_x = pos_x+dx[greedy_move];
			pos_y = pos_y+dy[greedy_move];
		}
		else if(options>1)
		{
			while(1)
			{
				greedy_move = rand()%4;
				if(select_option[greedy_move])
					break;
			}
			pos_x = pos_x+dx[greedy_move];
			pos_y = pos_y+dy[greedy_move];
		}
		else
		{
			br = true;
			while(br)
			{
				for(i=0;i<4;i++)
				{
					x = pos_x+dx[i];
					y = pos_y+dy[i];
					if(x<0||x>=size_x||y<0||y>=size_y)
						continue;
					br = false;
					break;
				}
			}
		}
			
		if(greedy_move==0)
			printf("U %.2lf\n", score);
		else if(greedy_move==1)
			printf("R %.2lf\n", score);
		else if(greedy_move==2)
			printf("D %.2lf\n", score);
		else if(greedy_move==3)
			printf("L %.2lf\n", score);
		moves--;
		n++;
		if(n%print==0&&n>0)
			print_fn();
	}
	return;
}

int main()
{
	int i, j, k, l;
	char buf[100];
	scanf("GRID: %d %d", &size_x, &size_y);
	//printf("%d %d\n", size_x, size_y);
	scanf("%s", &buf);
	//printf("%s\n", buf);
	for(i=0;i<size_x;i++)
		for(j=0;j<size_y;j++)
		{
			scanf("%lf", &grid[i][j]);
			//printf("%lf ", grid[i][j]);
		}
	scanf("%s %d", &buf, &moves);
	//printf("%d\n", moves);
	scanf("%s %d %d", &buf, &pos_x, &pos_y);
	//printf("%d %d\n", pos_x, pos_y);
	print = N;
	pos_x--;
	pos_y--;
	print_fn();
	score=0.0;
	n=0;
	compute();
	printf("Final Score = %lf\n", score);
	return 0;
}
