#include<stdio.h>
#include <time.h>
#include<stdlib.h>

using namespace std;

#define max 1010
#define N 5

double grid[max][max];
bool known[max][max];
double score;
int size_x, size_y, pos_x, pos_y, moves, print, n, x, y, lastmove;
int dx[4] = {-1, 0, 1, 0};
int dy[4] = {0, 1, 0, -1};
bool select_option[4];
bool suck;
int go_to;

void print_fn()
{
	int i, j;
	for(i=0;i<size_x;i++)
	{
		for(j=0;j<size_y;j++)
			if(pos_x==i&&pos_y==j)
				printf("[%.2lf] ", grid[i][j]);
			else
				printf("%.2lf ", grid[i][j]);
		printf("\n");
	}
	printf("\n");
}

double find_cost(int px, int py, int mv)
{
	double change, lcost, ucost, rcost, dcost;
	if(px<0||px>=size_x||py<0||py>=size_y)
		return 0.000000;
	if(mv<=0)
		return 0.000000;
	if(known[px][py]==false)
		return 0.00000;
	lcost = find_cost(px, py-1, mv-2);
	ucost = find_cost(px-1, py, mv-2);
	rcost = find_cost(px, py+1, mv-2);
	dcost = find_cost(px+1, py, mv-2);
	change = lcost;
	go_to = 3;
	if(change<rcost)
	{
		change = rcost;
		go_to = 1;
	}
	if(change<ucost)
	{
		change = ucost;
		go_to = 0;
	}
	if(change<dcost)
	{
		change=dcost;
		go_to = 2;
	}
	return grid[px][py]+change;
}

void compute()
{
	srand(time(0));
	int i, greedy_move, options, j, x, y;
	bool br;
	for(i=0;i<size_x;i++)
		for(j=0;j<size_y;j++)
			known[i][j] = false;
			
	double change, lcost, ucost, rcost, dcost;
	while(moves>0)
	{
		//Rational
		for(i=0;i<4;i++)
		{
			x = pos_x+dx[i];
			y = pos_y+dy[i];
			if(x<0||x>=size_x||y<0||y>=size_y)
				continue;
			known[x][y] = true;
		}
		
		score+=grid[pos_x][pos_y];
		known[pos_x][pos_y] = true;
		grid[pos_x][pos_y] = 0.0;
		moves--;
		n++;
		
		change = find_cost(pos_x, pos_y, moves);
		//printf("%d\n", go_to);
		
		if(!change>0.0)
		{
			//printf("Here at %d\n", moves);
			if(2*pos_x<size_x)
			{
				if(2*pos_y<size_y)
					go_to = 1;
				else
					go_to = 2;
			}
			else
			{
				if(2*pos_y<size_y)
					go_to = 0;
				else
					go_to = 3;
			}
			if(lastmove>=0&&(go_to+lastmove)%2==0)
			{
				br = true;
				while(br)
				{
					for(i=0;i<4;i++)
					{
						x = pos_x+dx[i];
						y = pos_y+dy[i];
						if(x<0||x>=size_x||y<0||y>=size_y)
							continue;
						if(lastmove<0)
						{
							br = false;
							break;
						}
						else if((i+lastmove)%2!=0)
						{
							br = false;
							break;
						}
					}
				}
			}
		}
		//printf("Change %lf Before %d %d\n", change, pos_x, pos_y);
		pos_x += dx[go_to];
		pos_y += dy[go_to];
		lastmove = go_to;
		//printf("%d %d %d\n", go_to, pos_x, pos_y);
		if(go_to==0)
			printf("U %.2lf\n", score);
		else if(go_to==1)
			printf("R %.2lf\n", score);
		else if(go_to==2)
			printf("D %.2lf\n", score);
		else if(go_to==3)
			printf("L %.2lf\n", score);
		moves--;
		n++;
		if(n%print==0&&n>0)
			print_fn();
	}
	return;
}

int main()
{
	int i, j, k, l;
	char buf[100];
	scanf("GRID: %d %d", &size_x, &size_y);
	scanf("%s", &buf);
	for(i=0;i<size_x;i++)
		for(j=0;j<size_y;j++)
			scanf("%lf", &grid[i][j]);
	scanf("%s %d", &buf, &moves);
	scanf("%s %d %d", &buf, &pos_x, &pos_y);
	print = N;
	pos_x--;
	pos_y--;
	print_fn();
	score=0.0;
	n=0;
	lastmove = -1;
	compute();
	printf("Final Score = %lf\n", score);
	return 0;
}
